;
;	Zenelejtsz program VT-DOS-ra
;
;
;


	.org 0100h			; a VT-DOS programok betltsi cme


pmain:	ld	sp,03FF0h		; sajt veremterlet kialaktsa U0 tetejn
	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	ld	(0003Bh),a
	out	(002h),a		; memrialapozs belltsa
	ld	hl,0005Dh		; HL az els paramterben megadott 8+3 -as fjlnvre mutat
	call	rw4open			; fjl megnyitsa
	jr	nz,exit			; ugrs, ha nem sikerlt megnyitni
	ld	a,(00052h)		; A reg.= diszk RAM belapozsi rtke
	ld	c,a
	rra				; 7. s 6. bit jobbra lptetse 2-vel
	rra
	and	030h			; jobbra lptetett bitek megtartsa
	xor	0EFh			; bziscm fels bjtjnak hozzadsa
	ld	h,a			; HL Port3 msolatra mutat a diszk RAM-ban
	ld	l,0FEh
	ld	a,c			; A reg.= diszk RAM belapozsi rtke
	di
	out	(002h),a		; memrialapozs belltsa
	ld	a,(hl)
	ld	(Port3),a		; Port3 rtke a sajt vltozba
	dec	hl
	ld	a,(hl)
	ld	(Port5),a		; Port5 rtke a sajt vltozba
	ld	a,090h			; U0,U1,VID,U3 lapozs
	ld	(0003Bh),a
	out	(002h),a		; felhasznli memrialapozs belltsa
	ei
	call	ed_dosoff		; VT-DOS kurzor kikapcsolsa
	ld	hl,hszkep		; HL a hangszr kp kezdcmre mutat
	call	kirajz			; kp kirajzolsa
	call	playinf			; lejtszsi informcik kirsa
	call	rw4play			; zene lejtszsa
	call	settime			; rendszerid utnlltsa
	ld	c,000h			; 2-szn md belltsa
	call	kepmod
	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	ld	(0003Bh),a
	out	(002h),a		; memrialapozs belltsa
	call	ed_doson		; VT-DOS kurzor bekapcsolsa
;
exit:	jp	0000h			; vissza a VT-DOS-ba




;
;
;	Lejtszsi informcik kirsa
;	in:  -
;	out: -
;
playinf:ld	bc,00101h
	call	ed_doscpos		; konzol kurzorpozci a bal fels sarokba
	ld	hl,0005Dh		; HL az els paramterben megadott 8+3 -as fjlnvre mutat
	ld	de,puffer
	call	fname			; fjlnv msolsa a pufferbe
	ld	a,'$'
	ld	(de),a			; stringet zr karakter elhelyezse
	ld	de,puffer
	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
;
	ld	de,fstext		; mintavteli frekvencia kirsa
	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
	ld	de,(pitch)
	ld	hl,01000h		; HL= 4096
	or	a
	sbc	hl,de			; HL= 4096 - PITCH
	add	hl,hl			; HL= (4096 - PITCH) * 2
	ex	de,hl			; oszt DE-be
	ld	bc,00005h		; BC:HL= 195312.5 * 2
	ld	hl,0F5E1h
	call	ut_div32
	ld	(num_L),hl		; eredmny trolsa
	ld	(num_H),bc
	ld	hl,num_H + 1
	ld	de,puffer
	call	ut_ascc			; szm kirsa a string pufferbe
	ld	a,'$'
	ld	(de),a			; stringet zr karakter elhelyezse
	ld	de,puffer + 4		; az els 4 karakter biztosan szkz, ezt nem rja ki
	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
	ld	de,hztext
	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
;
	ld	de,pttext		; lejtszsi id kirsa
	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
	ld	bc,(FCB_0 + 019h)	; BC= fjlmret fels szava
	ld	de,(FCB_0 + 017h)	; DE= fjlmret als szava
	call	ptcalc			; jtszsi id kiszmtsa a fjlmretbl
	push	de
	push	hl
	ld	de,puffer		; DE a stringpufferre mutat
	ld	a,h
	call	ut_bcon			; rk kirsa
	ld	a,':'
	ld	(de),a
	inc	de
	pop	hl
	ld	a,l
	call	ut_bcon			; percek kirsa
	ld	a,':'
	ld	(de),a
	inc	de
	pop	hl
	ld	a,h
	call	ut_bcon			; msodpercek kirsa
	ld	a,'$'
	ld	(de),a			; stringet zr karakter elhelyezse
	ld	de,puffer
	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
;
	ld	bc,02A17h		; B= 42.oszlop  C= 23.sor
	call	ed_doscpos		; kurzor belltsa
	ld	de,qutext		; kilpsi szveg kirsa
	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
	ret


;
;
;	Rendszerid mdostsa (ha a dtum tfordulna, akkor nem mdostja az idt sem)
;	in:  -
;	out: -
;
settime:ld	bc,(FCB_0 + 02Ah)	; BC= fjlmutat fels szava
	ld	de,(FCB_0 + 028h)	; DE= fjlmutat als szava
	call	ptcalc			; eltelt id kiszmtsa a fjlmutatbl
	push	hl
	push	de
	ld	c,02Ch			; C= funkcikd: id beolvassa
	call	0005h			; VT-DOS hvsa
	ex	(sp),hl			; H= eltelt msodpercek
	ld	a,d
	add	a,h
	cp	60
	jr	c,stime0		; ugrs, ha nincs tvitel a msodpercrl
	sub	60
stime0:	ccf
	ld	d,a			; D= mdostott msodpercek
	pop	bc			; B= rk  C= percek
	pop	hl			; H= eltelt rk  L= eltelt percek
	ld	a,c
	adc	a,l			; percek nvelse
	cp	60
	jr	c,stime1		; ugrs, ha nincs tvitel a percrl
	sub	60
stime1:	ccf
	ld	l,a			; L= mdostott percek
	ld	a,b
	adc	a,h			; rk nvelse (dtumot nem nveli!)
	ld	h,a			; H= mdostott rk
	cp	24			; rk tfordulsnak ellenrzse
	ld	c,02Dh			; C= funkcikd: id belltsa
	call	c,0005h			; VT-DOS hvsa, ha az rk nem fordultak t
	ret


;
;
;	Lejtszsi id kiszmtsa bjtszmbl
;	in:  BC - hossz fels szava
;	     DE - hossz als szava
;	out:  H - rk
;	      L - percek
;	      D - msodpercek
;	      E - szzadmsodpercek
;
ptcalc:	push	bc			; szorzand rtkek tmenetileg a verembe
	push	de
	ld	de,(pitch)
	ld	hl,01000h		; HL= 4096
	or	a
	sbc	hl,de			; HL= 4096 - PITCH
	add	hl,hl			; HL= (4096 - PITCH) * 2
	add	hl,hl			; HL= (4096 - PITCH) * 2 * 2 minta/bjt
	ld	b,h			; BC= szorz
	ld	c,l
	pop	de			; DE= szorzand als szava
	call	ut_mul			; szorzs elvgzse
	ex	(sp),hl			; eredmny fels sz mentse, szorzand fels sz HL-be
	ex	de,hl			; szorzand fels sz DE-be, eredmny als sz HL-be
	push	hl			; eredmny als sz a verembe
	call	ut_mul			; szorzs elvgzse a fels szra
	pop	bc			; eredmny als szava BC-be
	ex	(sp),hl			; korbbi szorzs fels szava HL-be, mostani eredmny fels sz a verembe
	add	hl,de
	ex	de,hl			; eredmny kzps szava DE-be
	pop	hl			; eredmny fels szava HL-be
	jr	nc,ptcal0		; ugrs, ha nem volt tvitel a kzps szrl
	inc	hl			; fels sz nvelse
ptcal0:	ld	h,l			; eredmny szorzsa 256-al
	ld	l,d
	ld	d,e
	ld	e,b
	ld	b,c
	ld	c,000h			; HL:DE:BC = 2 minta/bjt * hossz * (4096 - PITCH) * 512 * 10^-8 sec
	push	ix
	push	bc
	pop	ix			; als sz IX-be
	ex	de,hl			; kzps sz HL-be, fels sz DE-be
	ld	c,100
	call	ut_div48		; eredmny osztsa 100-al
	call	ut_div48		; eredmny osztsa 100-al (sszesen 10^4)
	call	ut_div48		; eredmny osztsa 100-al (sszesen 10^6)
	ex	de,hl
	push	ix
	pop	hl			; 32 bites eredmny DE:HL-ben -> id szzadmsodpercben
	pop	ix
	call	ut_div32_8		; id osztsa 100-al
	push	af			; szzadmsodpercek a verembe
	ld	c,60
	call	ut_div32_8		; msodpercek osztsa 60-al
	pop	bc			; B= szzadmsodpercek
	ld	c,a			; C= msodpercek
	push	bc
	ld	c,60
	call	ut_div32_8		; percek osztsa 60-al
	pop	bc
	ld	h,l			; H= rk
	ld	l,a			; L= percek
	ld	d,c			; D= msodpercek
	ld	e,b			; E= szzadmsodpercek
	ret


;
;	VT-DOS konzol kurzor kikapcsolsa
;	in:  -
;	out: -
;
ed_dosoff:
	ld	de,curoff
	jr	ed_str


;
;	VT-DOS konzol kurzor bekapcsolsa
;	in:  -
;	out: -
;
ed_doson:
	ld	de,curon
ed_str:	ld	c,009h			; C= funkcikd: string output
	call	0005h			; VT-DOS hvsa
	ret


;
;	ESC szekvencik a kurzor be/ki kapcsolshoz
;

curoff:	.db	00Ch			; kperny trlse
	.db	01Bh,"x5"		; kurzor kikapcsolsa
	.db	'$'			; stringet zr '$' karakter

curon:	.db	00Ch			; kperny trlse
	.db	01Bh,"y5"		; kurzor bekapcsolsa
	.db	'$'			; stringet zr '$' karakter


;
;	VT-DOS konzol kurzor pozcionlsa
;	in:   B - oszlop (soron belli pozci)
;	      C - sor (1..24)
;	out: -
;
ed_doscpos:
	push	bc
	ld	e,01Bh			; ESC szekvencia kezdete
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ld	e,'Y'			; kurzor pozcinlsa
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	pop	bc
	push	bc
	ld	a,c			; sor
	add	a,01Fh			; 020h hozzadsa, -1 mert a konzol 0-tl szmoz
	ld	e,a
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	pop	bc
	ld	a,b			; oszlop
	add	a,01Fh			; 020h hozzadsa, -1 mert a konzol 0-tl szmoz
	ld	e,a
	ld	c,002h			; C= funkcikd: konzol output
	call	0005h			; VT-DOS hvsa
	ret


;
;
;	Szveg msolsa adott hosszon, a specilis karakter tlpsvel
;	in:   B - hossz
;	      C - specilis karakter
;	     DE - cl
;	     HL - forrs
;	out:  B - nem msolt karakterek szma
;	      C - megrzdik
;	     DE - utols msolt karakter utn mutat
;	     HL - az adott hossz utni karakterre mutat
;
fscpy:	ld	a,(hl)			; msoland karakter A reg.-be
	cp	c
	jr	z,fscp0			; ugrs, ha specilis karakter
	ld	(de),a
	inc	de
	inc	hl
	djnz	fscpy			; ismtls a megadott hosszig
	ret
;
fscp0:	ld	a,l			; forrscm nvelse, ha vannak nem msolt karakterek
	add	a,b
	ld	l,a
	ret	nc
	inc	h
	ret


;
;
;	Fjlnv kirsi formtumnak elksztse (fjlnv.kit formtumban)
;	in:  DE - cl cme
;	     HL - 8+3-as fjlnv cme
;	out: DE - az elksztett string utn mutat
;
fname:	ld	bc,00820h		; B = max. 8 karaktert msol   C = szkzket tlpi
	call	fscpy			; fjlnv msolsa
	ld	a,'.'
	ld	(de),a
	inc	de
	ld	b,003h			; tovbbi max. 3 karakter
	call	fscpy			; kitejeszts msolsa
	ld	a,b			; msolt karakterszm vizsglata
	cp	003h
	ret	nz			; visszatrs, ha legalbb egy karaktert msolt
	dec	de			; DE visszalptetse a '.' karakterre
	ret


;
;	Kls modulokbl beillesztend programrszek
;

;
	#include "keplib.asm"
;
	#include "rw4lib.asm"
;
	#include "util.asm"
;

fstext	.text	"\r\n\r\nMintav\221teli frekvencia: $"
hztext	.text	" Hz$"
pttext	.text	"\r\nJ\220t\221kid\225 (\223ra:perc:mp):   $"
qutext	.text	"Q (hosszan) - Kil\221p\221s$"
;
hszkep	.equ	$			; hangszrt brzol kp kezdete
;
dstart	.equ	hszkep + 0988h
FCB_0	.equ	dstart			; FCB0
FCB_1	.equ	dstart + 0030h		; FCB1
bcdMSB	.equ	dstart + 0060h		; BCD alak szm trolshoz a BIN->ASCII konverzinl (5 bjt)
bcdLSB	.equ	dstart + 0064h
num_L	.equ	dstart + 0065h		; szmbuffer BIN->BCD konverzhoz, als sz (2 bjt)
num_H	.equ	dstart + 0067h		; szmbuffer BIN->BCD konverzhoz, fels sz (2 bjt)
puffer	.equ	dstart + 0069h		; szabadon hasznlhat terlet


.end

